<?php
/**
 * Coppermine 1.6.x Plugin - html5slideshow
 *
 * Originally written by Ron Crans
 * Updated by KF to add photographer name and large control icons for version 1.5.0
 *
 * @copyright  Copyright (c) 2003-2023 Coppermine Dev Team
 * @license    GNU General Public License version 3 or later; see LICENSE
 *
 * plugins/html5slideshow/fullSlide.php
 * @since  1.6.22
 */
error_reporting(E_ALL);
ini_set('display_errors', '1');

$H5ss_jsf = 'slides';

if ($CONFIG['debug_mode']==1 || ($CONFIG['debug_mode']==2 && GALLERY_ADMIN_MODE)) {
	$H5ss_jsf .= '.js';
} else {
	$H5ss_jsf .= '.min.js';
}

$H5ss_cfg = json_decode($CONFIG['html5slideshow_cfg'], true);

$uid = USER_ID;
$usrData = cpg_db_fetch_assoc(cpg_db_query("SELECT `H5ss_cfg` FROM {$CONFIG['TABLE_USERS']} WHERE user_id = {$uid}"));
if ($usrCfg = json_decode($usrData['H5ss_cfg'], true)) {
	$H5ss_cfg = array_merge($H5ss_cfg, $usrCfg);
}
$errmsg = '';
$filelist = array();
$usrisown = false;

if ($superCage->get->testAlpha('album')) {
	$album = $superCage->get->getAlpha('album');
} else {
	$album = $superCage->get->getInt('album');
	$albData = cpg_db_fetch_assoc(cpg_db_query("SELECT `H5ss_cfg`,owner FROM {$CONFIG['TABLE_ALBUMS']} WHERE aid = {$album}"));
	if (!$albData) {
	    cpg_die(ERROR, $lang_errors['non_exist_ap']);
	}
	if ($albCfg = json_decode($albData['H5ss_cfg'], true)) {
		$H5ss_cfg = array_merge($H5ss_cfg, $albCfg);
	}
	$usrisown = $H5ss_cfg['uA'] && (USER_ID === $albData['owner']);
}

if (!USER_ID && $CONFIG['allow_unlogged_access'] < 3) {
	$H5ss_cfg['pS'] = 1;
}

$fprefix = $H5ss_cfg['pS'] == 1 ? 'normal_' : '';
get_meta_album_set($superCage->get->getInt('cat'));
$count = 0;
$album_name = '';
$rowset = get_pic_data($album, $count, $album_name);
if ($rowset) {
	if ($pid = $superCage->get->getInt('pid')) {
		for ($i=0; $i<count($rowset); $i++) {
			if ($rowset[$i]['pid'] == $pid) break;
		}
		if ($i > 0) $rowset = array_merge(array_slice($rowset, $i), array_slice($rowset, 0, $i));
	}
	foreach ($rowset as $row) {
		$ftyp = cpg_get_type($row['filename']);
		if (!in_array($ftyp['content'], array('image','movie'))) continue;

        // KF Add code to display photographer name and add title & description if selected in config  
        $owner_id = $row['owner_id'];
        $pid = $row['pid'];
        $query = "SELECT user_name FROM {$CONFIG['TABLE_USERS']} INNER JOIN {$CONFIG['TABLE_PICTURES']} ON user_id = owner_id WHERE pid = $pid";

        if ($usrData = cpg_db_fetch_assoc(cpg_db_query($query))) {
            $photographer = $usrData['user_name'];
        }
        else {
            $photographer = $lang_plugin_html5slideshow['Photognf'];
        };     
        $phottext = ($H5ss_cfg['vP'] && trim($photographer)) ? $photographer : "";
        $titletext = ($H5ss_cfg['vT'] && trim($row['title'])) ? trim($row['title']) : "";
        $sep = ($phottext && $titletext) ? " :: " : "";
        $capttext = ($H5ss_cfg['vD'] && trim($row['caption'])) ? str_replace(array("\r\n", "\n", "\r"), " ", $row['caption']) : "";
        $sep2 =  $capttext && ($phottext || $titletext) ? "\n" : ""; 
        $txtinfo = $phottext . $sep . $titletext . $sep2 . $capttext;
//      KF Strip out extra spaces, add line break between title and description and replace line breaks in the description by a space
//		if ($H5ss_cfg['vD'] && trim($row['caption'])) $txtinfo = $txtinfo . "\n" . str_replace(array("\r\n", "\n", "\r"), " ", $row['caption']);
		$fileentry = array(
				'fpath' => get_pic_url($row, ($H5ss_cfg['pS'] == 1 ? 'normal' : 'fullsize')),
				'height' => $row['pheight'],
				'title' => bb_decode($txtinfo),
				'mTyp' => $ftyp['content'][0]
				);
		$filelist[] = $fileentry;
	}
} else {
	$errmsg .= $lang_plugin_html5slideshow['noimgerr'];
}
if (!count($filelist)) $errmsg .= $lang_plugin_html5slideshow['noimgerr'];
if ($H5ss_cfg['sI']) shuffle($filelist);
$popdwin = ($superCage->get->getInt('h5sspu') == 1);
$icons = $H5ss_cfg['iS'];
$dcolors = $H5ss_cfg['dC'];
$fntSize = array('inherit','small', 'medium','large','larger','x-large','xx-large')[isset($H5ss_cfg['tS']) ? $H5ss_cfg['tS'] : 0];
// KF Test icon file height and set large parameter if large (24 pixels high)
$iconfile = "plugins/html5slideshow/css/icons/" . $icons . ".png";
$iconsize = cpg_getimagesize($iconfile); 
// $iconfileheight = $iconsize[1];
// error_log("Icon height = " . $iconfileheight, 0);
// KF Add large code
if ($iconsize[1] == 24) {
    $large = "_large";
} else {
    $large = "";
};
?>
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US" xml:lang="en-US" dir="<?=$lang_text_dir?>">

<head>
<meta http-equiv="Content-Type" content="text/html; charset=<?=$CONFIG['charset'] == 'language file' ? $lang_charset : $CONFIG['charset']?>" />
<title><?=strip_tags($album_name)?> :: <?=$lang_plugin_html5slideshow['ssword']?></title>
<meta name="viewport" content="initial-scale=1.0, minimum-scale=1.0, maximum-scale=1.0, user-scalable=no, width=device-width, height=device-height" />
<link rel="stylesheet" type="text/css" href="plugins/html5slideshow/css/slides.css">
<link rel="stylesheet" type="text/css" href="<?=$CONFIG['ecards_more_pic_target']?>/<?=$THEME_DIR?>style.css">
<style type="text/css">
	html { height:100%; overflow:hidden }
	body { background-color:<?=$dcolors[4]?>; width:100%; height:100%; overflow:hidden }
	div#controls { background-color:<?=$dcolors[0]?>; color:<?=$dcolors[1]?>; }
	div#ptext { background-color:<?=$dcolors[2]?>; color:<?=$dcolors[3]?>; font-size:<?=$fntSize?>; position:absolute; z-index:9; }
	div.albnam { color:<?=$dcolors[3]?>; font-size:<?=$fntSize?>; }
	div#screen { background-color:<?=$dcolors[4]?>; overflow:hidden; }
	div.spribut<?=$large?> { background: url('plugins/html5slideshow/css/icons/<?=$icons?>.png') no-repeat; }
</style>
<script src="<?=CPG_JQUERY_VERSION?>" type="text/javascript"></script>
<script src="plugins/html5slideshow/js/jquery.touchSwipe.min.js" type="text/javascript"></script>
<script src="plugins/html5slideshow/js/<?=$H5ss_jsf?>" type="text/javascript"></script>
<script type="text/javascript">
	var albumID = '<?=$album?>';
	var popdwin = <?=$popdwin?'true':'false'?>;
	var imagelist = <?=json_encode($filelist)?>;
	var imgerror = "<?=$lang_plugin_html5slideshow['imgerror']?>";
	var viderror = "<?=$lang_plugin_html5slideshow['viderror']?>";
	ssCtl.autoPlay = <?=$H5ss_cfg['aP']*1?>;
	ssCtl.repeat = <?=$H5ss_cfg['lS']?'true':'false'?>;
	ssCtl.slideDur = <?=$H5ss_cfg['sD']*1000?>;
	ssCtl.trnType = "<?=$H5ss_cfg['tT']?>";
	function asscfg() {
		var csl = "index.php?file=html5slideshow/config&album="+albumID;
		if (popdwin) { parent.opener.location = csl; window.close(); }
		else { window.location = csl; }
	}
</script>
</head>

<body>
<?php if ($errmsg): ?>
	<div id="ptext" style="font-size:1.5em"><?=$errmsg?>&nbsp;&nbsp;<button type="button" onclick="ssCtl.doMnu(0)"><?=$lang_plugin_html5slideshow['stop_a']?></button></div>
<?php else: ?>
	<div id="fullarea" style="height:100%">
		<div id="controls">
			<div class="albnam"><span id="albNam"><?=$album_name?>&nbsp;&nbsp;::&nbsp;&nbsp;</span><?=sprintf($lang_plugin_html5slideshow['of_format'],'<span id="slidnum"></span>',count($filelist))?></div>
		<?php if ($H5ss_cfg['uA'] && USER_ID>0): ?>
			<img class="sscfg" src="images/icons/config.png" width="16" height="16" onclick="asscfg()" title="<?=$lang_plugin_html5slideshow['configss']?>" alt="config" />
		<?php endif; ?>
			<div class="ofslid">
				<div id="cb_less<?=$large?>" class="spribut<?=$large?>" onclick="ssCtl.sdur(0)" title="<?=$lang_plugin_html5slideshow['minus']?>"></div>
				<span id="seconds"></span>&nbsp;<?=$lang_plugin_html5slideshow['secsabrv']?> 
				<div id="cb_more<?=$large?>" class="spribut<?=$large?>" onclick="ssCtl.sdur(1)" title="<?=$lang_plugin_html5slideshow['plus']?>"></div>
			</div>
			<div class="sldctls">
				<div id="cb_stop<?=$large?>" class="spribut<?=$large?>" onclick="ssCtl.doMnu(0)" title="<?=$lang_plugin_html5slideshow['stop_t']?>"></div>
				&nbsp;
				<div id="cb_rwnd<?=$large?>" class="spribut<?=$large?>" onclick="ssCtl.doMnu(1)" title="<?=$lang_plugin_html5slideshow['rwnd_t']?>"></div>
				<div id="cb_prev<?=$large?>" class="spribut<?=$large?>" onclick="ssCtl.doMnu(2)" title="<?=$lang_plugin_html5slideshow['prev_t']?>"></div>
				<div id="cb_paus<?=$large?>" class="spribut<?=$large?>" onclick="ssCtl.doMnu(3)" title="<?=$lang_plugin_html5slideshow['togl_t']?>"></div>
				<div id="cb_next<?=$large?>" class="spribut<?=$large?>" onclick="ssCtl.doMnu(4)" title="<?=$lang_plugin_html5slideshow['next_t']?>"></div>
				<div id="cb_last<?=$large?>" class="spribut<?=$large?>" onclick="ssCtl.doMnu(5)" title="<?=$lang_plugin_html5slideshow['last_t']?>"></div>
				&nbsp;&nbsp;
				<div id="cb_full<?=$large?>" class="spribut<?=$large?>" onclick="ssCtl.doMnu(6)" title="<?=$lang_plugin_html5slideshow['full_t']?>"></div>
			</div>
		</div>
		<div id="ptext"></div>
		<div id="screen" style="height:100%;-webkit-backface-visibility:hidden;">
			<p id="loading" style="display:none">∙∙∙LOADING∙∙∙</p>
		</div>
		<!-- <div id="status"></div> -->
	</div>
<?php endif; ?>
</body>

</html>
